#ifndef __STDGB_H
#define __STDGB_H
//
//  (C) Copyright 1993-2008 by Autodesk, Inc.  All rights reserved.
//
// Permission to use, copy, modify, and distribute this software in
// object code form for any purpose and without fee is hereby granted, 
// provided that the above copyright notice appears in all copies and 
// that both that copyright notice and the limited warranty and
// restricted rights notice below appear in all supporting 
// documentation.
//
// AUTODESK PROVIDES THIS PROGRAM "AS IS" AND WITH ALL FAULTS. 
// AUTODESK SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTY OF
// MERCHANTABILITY OR FITNESS FOR A PARTICULAR USE.  AUTODESK, INC. 
// DOES NOT WARRANT THAT THE OPERATION OF THE PROGRAM WILL BE
// UNINTERRUPTED OR ERROR FREE.
//
// Use, duplication, or disclosure by the U.S. Government is subject to 
// restrictions set forth in FAR 52.227-19 (Commercial Computer
// Software - Restricted Rights) and DFAR 252.227-7013(c)(1)(ii)
// (Rights in Technical Data and Computer Software), as applicable.
//

#ifndef __STDISO_H
#error include 'stdISO.h' before including this file
#endif

class STDIMP_DLLSHARE AcmStandardGB : public AcmStandardISO
{
public:
  ACRX_DECLARE_MEMBERS(AcmStandardGB);

  AcmStandardGB();
  virtual ~AcmStandardGB();
  virtual LPCTSTR originalName() const;             
  virtual Adesk::Boolean acmInit();             
  virtual Acad::ErrorStatus dxfOutFields(AcDbDxfFiler* filer) const;             
protected:
  virtual void initArrowServices();
  virtual Adesk::Boolean createDefaultStyle();
};                      

MAKE_ACDBOPENOBJECT_FUNCTION(AcmStandardGB);


class STDIMP_DLLSHARE AcmBOMStdGB : public AcmBOMStdISO
{
public:
  ACRX_DECLARE_MEMBERS(AcmBOMStdGB);

  AcmBOMStdGB();
  virtual ~AcmBOMStdGB();

  virtual Acm::ErrorStatus cInit();
  virtual Acm::ErrorStatus getRevision(CString& rev, Adesk::UInt16& year) const;
  virtual Adesk::Boolean   isCompatibleTo(const AcmStandard* pStd) const;
  virtual Adesk::Boolean   isCreatedFor(const AcmStandard* pStd) const;
  virtual Adesk::Boolean setFactoryDefaults();

protected:
   virtual HINSTANCE serviceResourceHandle() const;
};
MAKE_ACDBOPENOBJECT_FUNCTION(AcmBOMStdGB);


class STDIMP_DLLSHARE AcmCPartListStdGB : public AcmCPartListStdISO
{
public:
  AcmCPartListStdGB(AcmBOMStd *std);
  virtual ~AcmCPartListStdGB();
  virtual Adesk::Boolean setFactoryDefaults();
  virtual Acm::ErrorStatus getRevision(CString& rev, Adesk::UInt16& year) const;
};


class STDIMP_DLLSHARE AcmCBalloonStdGB : public AcmCBalloonStdISO
{
public:
  AcmCBalloonStdGB(AcmBOMStd *std);
  virtual ~AcmCBalloonStdGB();

  virtual Acm::ErrorStatus cInit();
  virtual Adesk::Boolean setFactoryDefaults();
  virtual Acm::ErrorStatus getRevision(CString& rev, Adesk::UInt16& year) const;
};


class STDIMP_DLLSHARE AcmSurfTextStdGB : public AcmSurfTextStdISO
{
public:
  ACRX_DECLARE_MEMBERS(AcmSurfTextStdGB);

  AcmSurfTextStdGB();
  virtual ~AcmSurfTextStdGB();
  virtual Acm::ErrorStatus getRevision(CString& rev, Adesk::UInt16& year) const;
  virtual Adesk::Boolean   isCompatibleTo(const AcmStandard* pStd) const;
  virtual Adesk::Boolean   isCreatedFor(const AcmStandard* pStd) const;
  virtual Acm::ErrorStatus checkVisibility(AcmCSurfText* pData) const;
  virtual bool getSubEntsProd1(const AcmCSurfText* pSubSym,
                               AcmCAuxEntArray& subents,
                               AcDbExtents& fullExtent,
                               double txtHeight,
                               double& commonWidth,
                               AcGePoint3d& refPoint) const;
  virtual bool getSubEntsSampLen(const AcmCSurfText* pSubSym,
                                 AcmCAuxEntArray& subents,
                                 AcDbExtents& fullExtent,
                                 double txtHeight,
                                 double& commonWidth,
                                 AcGePoint3d& refPoint) const;
  virtual bool getSubEntsOtherVal(const AcmCSurfText* pSubSym,
                                  AcmCAuxEntArray& subents,
                                  AcDbExtents& fullExtent,
                                  double txtHeight,
                                  double& commonWidth,
                                  AcGePoint3d& refPoint) const;
  virtual bool getSubEntsOtherMin(const AcmCSurfText* pSubSym,
                                  AcmCAuxEntArray& subents,
                                  AcDbExtents& fullExtent,
                                  double txtHeight,
                                  double& commonWidth,
                                  AcGePoint3d& refPoint) const;
  virtual Acad::ErrorStatus dxfOutFields(AcDbDxfFiler* filer) const;

  virtual Acad::ErrorStatus getVarFromDlgIndex(Adesk::UInt8 dlgIndex, Acm::Variable& var) const;
  virtual AcmSurfTextStd::ConfigListState checkConfigListState(Acm::Variable var, CVarDlgInfo& varDlgInfo) const;
  virtual void getDefaultVarSuggestList(Acm::Variable var, CStringList& list) const;

protected:
  virtual void getHeights(const AcmCSurfText* pSymb,
                          double& H1,
                          double& H2) const;
  virtual double getHeightCorrect(const AcmCSurfText* pSubSym) const;
  virtual double getTailLength(const AcmCSurfText* pSubSym,
                               AcDbExtents& fullExtent,
                               AcGePoint3d& refPoint) const;
};                      

MAKE_ACDBOPENOBJECT_FUNCTION(AcmSurfTextStdGB);


class STDIMP_DLLSHARE AcmFCFStdGB : public AcmFCFStdISO
{
public:
  ACRX_DECLARE_MEMBERS(AcmFCFStdGB);

  AcmFCFStdGB();
  virtual ~AcmFCFStdGB();

  virtual Adesk::Boolean setFactoryDefaults();
  virtual Acm::ErrorStatus getRevision(CString& rev, Adesk::UInt16& year) const;
  virtual Adesk::Boolean   isCompatibleTo(const AcmStandard* pStd) const;
  virtual Adesk::Boolean   isCreatedFor(const AcmStandard* pStd) const;
  virtual Adesk::Boolean getMat(AcmCObjArray<AcmCGDTSymbolDesc>& list) const;
  virtual void getSubEnts(const AcmCFCF* pSymb,
                          AcmCAuxEntArray& subents, AcGePoint3d* = NULL) const;
  virtual Adesk::Boolean getSymbolImp(int subSym,
                                      CString& symtext) const;
  virtual Acad::ErrorStatus dwgInFields(AcDbDwgFiler* filer);
  virtual Acad::ErrorStatus dxfOutFields(AcDbDxfFiler* filer) const;
  virtual Acm::ArrowType defaultSecondaryArrowType() const;
};                      

MAKE_ACDBOPENOBJECT_FUNCTION(AcmFCFStdGB);


class STDIMP_DLLSHARE AcmWeldingStdGB : public AcmWeldingStdISO
{
public:
  ACRX_DECLARE_MEMBERS(AcmWeldingStdGB);
  AcmWeldingStdGB();
  virtual ~AcmWeldingStdGB();
  virtual Acm::ErrorStatus getRevision(CString& rev, Adesk::UInt16& year) const;
  virtual Adesk::Boolean   isCompatibleTo(const AcmStandard* pStd) const;
  virtual Adesk::Boolean   isCreatedFor(const AcmStandard* pStd) const;
  virtual Acm::ErrorStatus cInit();
  virtual void getSubEnts(const AcmCSubWelding* pSubSym,
                          AcmCAuxEntArray& subents,
                          AcGePoint3d& ptRefEnd) const;
  virtual Acad::ErrorStatus dxfOutFields(AcDbDxfFiler* filer) const;
};                      

MAKE_ACDBOPENOBJECT_FUNCTION(AcmWeldingStdGB);


class STDIMP_DLLSHARE AcmDatumStdGB : public AcmDatumStdISO
{
public:
  ACRX_DECLARE_MEMBERS(AcmDatumStdGB);

  AcmDatumStdGB();
  virtual ~AcmDatumStdGB();
  virtual Acm::ErrorStatus getRevision(CString& rev, Adesk::UInt16& year) const;
  virtual Adesk::Boolean   isCompatibleTo(const AcmStandard* pStd) const;
  virtual Adesk::Boolean   isCreatedFor(const AcmStandard* pStd) const;
  virtual Acad::ErrorStatus dxfOutFields(AcDbDxfFiler* filer) const;
};                      

MAKE_ACDBOPENOBJECT_FUNCTION(AcmDatumStdGB);


class STDIMP_DLLSHARE AcmIdStdGB : public AcmIdStdISO
{
public:
  ACRX_DECLARE_MEMBERS(AcmIdStdGB);
  
  AcmIdStdGB();
  virtual ~AcmIdStdGB();
  virtual Acm::ErrorStatus getRevision(CString& rev, Adesk::UInt16& year) const;
  virtual Adesk::Boolean   isCompatibleTo(const AcmStandard* pStd) const; 
  virtual Adesk::Boolean   isCreatedFor(const AcmStandard* pStd) const;
  virtual Adesk::Boolean isSupportedType(Acm::SubSymbolType type) const;
  virtual Adesk::Boolean isLandingSupported(Acm::SubSymbolType type) const;
  virtual double nonDrawingDistance(AcmCId* pData) const;
  virtual Adesk::Boolean getDatumArrowDesc(AcmCObjArray<AcmCArrowDesc>& list) const;
  virtual Acm::ArrowType defaultArrowType() const;
  virtual void getSubEnts(const AcmCId* pSymb,
                          AcmCAuxEntArray& subents) const;
  virtual Acad::ErrorStatus dxfOutFields(AcDbDxfFiler* filer) const;  
  virtual Adesk::Boolean allowedInclinedDatum() const;
};

MAKE_ACDBOPENOBJECT_FUNCTION(AcmIdStdGB);

#endif // __STDGB_H 